#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

double* maxPtr (double value[], int arrayLen);

int main()
{
	const int ARRAY_LEN = 100;
	double value[ARRAY_LEN] = {0};
	
	srand(time(0));
	// generate random values
	for (int i = 0; i < ARRAY_LEN; i++)
		value[i] = static_cast<double> (rand() % 10001) / 100;

	double* ptrGMax = maxPtr (value, ARRAY_LEN);

	// output the result
	cout << *ptrGMax << endl;
	cout << ptrGMax - value << endl;
	
	return 0;
}

double* maxPtr (double value[], int arrayLen)
{
	double* ptrLMax = value;
	double* ptrGMax = value;
	
	for (int i = 0; i < arrayLen - 1; i++)
	{
		if (value[i] > value[i + 1])
		{
			ptrLMax = &value[i];
			
			if (*ptrLMax > *ptrGMax)
				ptrGMax = ptrLMax;
		}
	}
	
	if (value[arrayLen - 1] > *ptrGMax)
		ptrGMax = &value[arrayLen - 1];
	
	return ptrGMax;
}
